﻿----------------------------------------------------------------------------
-- ©Copyright: ViperGTS96®--------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------
realDirtColor_LoadSettingsEvent = {};
realDirtColorLoadSettingsEvent_mt = Class(realDirtColor_LoadSettingsEvent, Event);
InitEventClass(realDirtColor_LoadSettingsEvent,"realDirtColor_LoadSettingsEvent");

function realDirtColor_LoadSettingsEvent:emptyNew()
    local self = Event.new(realDirtColorLoadSettingsEvent_mt);
    self.className = "realDirtColor_LoadSettingsEvent";
    return self;
end;

function realDirtColor_LoadSettingsEvent:new(simpleMode, maxWheelLimit, coldSlowsColor, realTimeSnowMelting, baseSpeed, revertSpeed)
	local self = realDirtColor_LoadSettingsEvent.emptyNew()
    self.simpleMode = simpleMode;
    self.maxWheelLimit = maxWheelLimit;
    self.coldSlowsColor = coldSlowsColor;
    self.realTimeSnowMelting = realTimeSnowMelting;
    self.baseSpeed = baseSpeed;
    self.revertSpeed = revertSpeed;
    return self;
end;

function realDirtColor_LoadSettingsEvent:readStream(streamId,connection)
    self.simpleMode = streamReadBool(streamId);
    self.maxWheelLimit = streamReadBool(streamId);
    self.coldSlowsColor = streamReadBool(streamId);
    self.realTimeSnowMelting = streamReadBool(streamId);
    self.baseSpeed = streamReadFloat16(streamId);
    self.revertSpeed = streamReadFloat16(streamId);
    self:run(connection);
end;

function realDirtColor_LoadSettingsEvent:writeStream(streamId,connection)
    streamWriteBool(streamId,self.simpleMode);
    streamWriteBool(streamId,self.maxWheelLimit);
    streamWriteBool(streamId,self.coldSlowsColor);
    streamWriteBool(streamId,self.realTimeSnowMelting);
    streamWriteFloat16(streamId,self.baseSpeed);
    streamWriteFloat16(streamId,self.revertSpeed);
end;

function realDirtColor_LoadSettingsEvent:run(connection)
    realDirtColor:rdcLoadSettingsEvent(self.simpleMode,self.maxWheelLimit, self.coldSlowsColor, self.realTimeSnowMelting, self.baseSpeed, self.revertSpeed, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(realDirtColor_LoadSettingsEvent:new(self.simpleMode,self.maxWheelLimit, self.coldSlowsColor, self.realTimeSnowMelting, self.baseSpeed, self.revertSpeed),nil,connection);
    end;
end;

function realDirtColor_LoadSettingsEvent.sendEvent(simpleMode, maxWheelLimit, coldSlowsColor, realTimeSnowMelting, baseSpeed, revertSpeed, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(realDirtColor_LoadSettingsEvent:new(simpleMode, maxWheelLimit, coldSlowsColor, realTimeSnowMelting, baseSpeed, revertSpeed));
        else
            g_client:getServerConnection():sendEvent(realDirtColor_LoadSettingsEvent:new(simpleMode, maxWheelLimit, coldSlowsColor, realTimeSnowMelting, baseSpeed, revertSpeed));
        end;
    end;
end;

 function realDirtColor:rdcLoadSettingsEvent(simpleMode, maxWheelLimit, coldSlowsColor, realTimeSnowMelting, baseSpeed, revertSpeed, noEventSend)
	realDirtColor_LoadSettingsEvent.sendEvent(simpleMode, maxWheelLimit, coldSlowsColor, realTimeSnowMelting, baseSpeed, revertSpeed, noEventSend);
	if not g_currentMission:getIsServer() then
		realDirtColor.simpleMode = simpleMode;
		realDirtColor.maxWheelLimit = maxWheelLimit;
		realDirtColor.coldSlowsColor = coldSlowsColor;
		realDirtColor.realTimeSnowMelting = realTimeSnowMelting;
		realDirtColor.speeds.body = MathUtil.clamp(baseSpeed, 0.0001, 0.01);
		realDirtColor.speeds.revert = MathUtil.clamp(revertSpeed, 1.5, 100.0);
		realDirtColor.speeds.wheels = realDirtColor.speeds.body*2;
		realDirtColor.speeds.revertFast = realDirtColor.speeds.revert/2;
		realDirtColor.speeds.white = realDirtColor.speeds.revert/4;
		realDirtColor.writeToLog = false;
		realDirtColor.debugging = false;
	end;
end;

realDirtColor_setRedDirtEvent = {};
realDirtColor_setRedDirtEvent_mt = Class(realDirtColor_setRedDirtEvent, Event);
InitEventClass(realDirtColor_setRedDirtEvent,"realDirtColor_setRedDirtEvent");

function realDirtColor_setRedDirtEvent:emptyNew()
    local self = Event.new(realDirtColor_setRedDirtEvent_mt);
    self.className = "realDirtColor_setRedDirtEvent";
    return self;
end;

function realDirtColor_setRedDirtEvent:new(useRedDirt)
	local self = realDirtColor_setRedDirtEvent.emptyNew()
    self.useRedDirt = useRedDirt;
    return self;
end;

function realDirtColor_setRedDirtEvent:readStream(streamId,connection)
    self.useRedDirt = streamReadBool(streamId);
    self:run(connection);
end;

function realDirtColor_setRedDirtEvent:writeStream(streamId,connection)
    streamWriteBool(streamId,self.useRedDirt);
end;

function realDirtColor_setRedDirtEvent:run(connection)
    realDirtColor:rdcSetRedDirtColorEvent(self.useRedDirt, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(realDirtColor_setRedDirtEvent:new(self.useRedDirt),nil,connection);
    end;
end;

function realDirtColor_setRedDirtEvent.sendEvent(useRedDirt, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(realDirtColor_setRedDirtEvent:new(useRedDirt));
        else
            g_client:getServerConnection():sendEvent(realDirtColor_setRedDirtEvent:new(useRedDirt));
        end;
    end;
end;

 function realDirtColor:rdcSetRedDirtColorEvent(useRedDirt, noEventSend)
	realDirtColor_LoadSettingsEvent.sendEvent(useRedDirt, noEventSend);
	if g_currentMission:getIsServer() and useRedDirt then
		realDirtColor:southernDirt();
	end;
end;